/* specify Win95 code */
#define _WIN95

//#include <stdlib.h>
#include <stdio.h>
#include <windows.h>
#include <winioctl.h>
#include "WinRTctl.h"
#include "Wrtreg.h"

/* macros */
#define PLUG_N_PLAY_DEVICE "\\WRTDEV%d.VXD"
#define ISA_DEVICE "\\VMM32\\WRTDEV%d.VXD"
#define MAX_NUMBER_OF_VXD 10
#define MAX_SESSION_NUMBER 257
#define INVALID_DEVICE_NUMBER -1
#define MAX_WINRT_NAME 15
#define MAX_REGISTRY_NAME 256
#define ALL_VxDs -2
#define _5ms 5UL
#define _50ms 50UL
#define _100ms 100UL
#define _500ms 500UL
#define _10000ms 10000UL

/* Defines extracted for VXDLDR.H (subject to change) */
/* VxDLoader Function Requests */
#define VXDLDR_APIFUNC_LOADDEVICE    1
#define VXDLDR_APIFUNC_UNLOADDEVICE  2

/* VxDLoader Error Codes */
#define VXDLDR_ERR_OUT_OF_MEMORY     1
#define VXDLDR_ERR_IN_DOS            2
#define VXDLDR_ERR_FILE_OPEN_ERROR   3
#define VXDLDR_ERR_FILE_READ         4
#define VXDLDR_ERR_DUPLICATE_DEVICE  5
#define VXDLDR_ERR_BAD_DEVICE_FILE   6
#define VXDLDR_ERR_DEVICE_REFUSED    7
#define VXDLDR_ERR_NO_SUCH_DEVICE    8
#define VXDLDR_ERR_DEVICE_UNLOADABLE 9
#define VXDLDR_ERR_ALLOC_V86_AREA   10
#define VXDLDR_ERR_BAD_API_FUNCTION 11

/* type definitions	*/
struct _W32IoctlPkt {
 USHORT W32IO_ErrorCode ;
 USHORT W32IO_DeviceID ;
 UCHAR  W32IO_ModuleName[1] ;
} ;

/* Define this structure to reserve space at the end of _W32IoctlPkt struct   */
/* for 31 more characters. 																   */
typedef struct {
    struct _W32IoctlPkt Res_DL_Pkt;
    UCHAR               Res_ModName[31];
} IOCTL_PKT;

typedef unsigned char	uInt8;
typedef long				int32;
typedef unsigned long	uInt32;
typedef unsigned char	*CStr;
typedef double				*PDOUBLE;

/*	type declarations	*/
enum SCtrlFunc {Start_Session = 0, End_Session};
enum DCtrlFunc {Start_Driver = 0, Stop_Driver};
enum MemCommand {MapMemory = 0, UnmapMemory};

struct Table {
	int32	*Handle;         /* Handle to session's configuration in Registry.	*/
	int32	Device;          /* Number of session's configuration in Registry.	*/
   PVOID PhysMem1;        /* Pointer to session's primary memory resources.	*/
   PVOID PhysMem2;        /* Pointer to session's secondary memory resources.	*/
	int32 Occurrence;	  	  /* LabVIEW occurrence to be set on interrupt.  		*/
   HWND  WndHandle;       /* LabVIEW window to be notified of interrupt.		*/
	HANDLE IsrEvent;   	  /* Handle to session's ISR synchronization object.	*/
   BOOL TerminateIsr;	  /* Flag to signal IsrFunction thread's termination.	*/
};

/*	function prototypes	*/
DWORD DriverControl(enum DCtrlFunc eTask, DWORD dwDeviceNumber);
DWORD DeviceToRegistry(PDEVICE pDevice);
DWORD UpdateRegValue(HKEY hKey, PCHAR pszName, PDEVICE_ITEM pItem);
DWORD DeleteDevice(CStr szDeviceID);
DWORD IsrFunction(HANDLE hSessionDevice);
BOOLEAN DriverToRegistry(PDEVICE  pDevice);

/* obsolete functions	*/
void Delay(DWORD dwMilliseconds);
int Search(int iKey, int List[], int nElements);

